# Agenda
[6] Web услуги. GЕТ и POST заявки. Изпращане на данни чрез HTML форми [Иван Арабаджийски]  

  

7 април  

  

REST услуги. It is a software architectural style created by Roy Fielding in 2000 to guide the design of architecture for the web. Any API (Application Programming Interface) that follows the REST design principle is said to be RESTful.


What's an API?
An API is a set of definitions and protocols for building and integrating application software. It’s sometimes referred to as a contract between an information provider and an information user—establishing the content required from the consumer (the call) and the content required by the producer (the response). For example, the API design for a weather service could specify that the user supply a zip code and that the producer reply with a 2-part answer, the first being the high temperature, and the second being the low.  

In other words, if you want to interact with a computer or system to retrieve information or perform a function, an API helps you communicate what you want to that system so it can understand and fulfill the request. 

You can think of an API as a mediator between the users or clients and the resources or web services they want to get. It’s also a way for an organization to share resources and information while maintaining security, control, and authentication—determining who gets access to what. 

HTTP functions as a request–response protocol in the client–server model.

Simply put, a REST API is a medium for two computers to communicate over HTTP (Hypertext Transfer Protocol), in the same way clients and servers communicate.
- REpresentational
- State
- Transfer

Client-server architecture?

HTTP Methods 
- get
- post
- update 
- delete

A server responds to CRUD (create, read, update, delete) requests in a standart way. What is a request? 

It's a software architectural style
What makes it restful?
- Client–server architecture
- Statelessness
- Cacheability
- Layered system


HTTP-based RESTful APIs are defined with the following aspects:

- a base URI, such as http://api.example.com/;
- standard HTTP methods (e.g., GET, POST, PUT, and DELETE);
- a media type that defines state transition data elements (e.g., Atom, microformats, application/vnd.collection+json, etc.). The current representation tells the client how to compose requests for transitions to all the next available application states. This could be as simple as a URI or as complex as a Java applet.[14]

Best practices:
1. Use JSON as the Format for Sending and Receiving Data
JavaScript, for example, has an inbuilt method to parse JSON data through the fetch API because JSON was primarily made for it. But if you are using any other programming language such as Python or PHP, they now all have methods to parse and manipulate JSON data as well.
To ensure the client interprets JSON data correctly, you should set the Content-Type type in the response header to application/json while making the request.

For server-side frameworks, on the other hand, many of them set the Content-Type automatically. Express, for example, now has the express.json() middleware for this purpose. The body-parser NPM package still works for the same purpose, too.

2. Use Nouns Instead of Verbs in Endpoints
When you're designing a REST API, you should not use verbs in the endpoint paths. The endpoints should use nouns, signifying what each of them does.

This is because HTTP methods such as GET, POST, PUT, PATCH, and DELETE are already in verb form for performing basic CRUD (Create, Read, Update, Delete) operations.

GET, POST, PUT, PATCH, and DELETE are the commonest HTTP verbs. There are also others such as COPY, PURGE, LINK, UNLINK, and so on.
So, for example, an endpoint should not look like this:

`https://mysite.com/getPosts` or `https://mysite.com/createPost`

Instead, it should be something like this: `https://mysite.com/posts`

In short, you should let the HTTP verbs handle what the endpoints do. So `GET` would retrieve data, `POST` will create data, `PUT` will update data, and `DELETE` will get rid of the data.

3. Name Collections with Plural Nouns
https://mysite.com/post/123 -> https://mysite.com/posts/123
4. Use Status Codes in Error Handling
|STATUS CODE RANGE	| MEANING
| -| -|
100 – 199| 	Informational Responses. <br> For example, 102 indicates the resource is being processed
300 – 399| 	Redirects <br> For example, 301 means Moved permanently
400 – 499| 	Client-side errors <br> 400 means bad request and 404 means resource not found
500 – 599| 	Server-side errors <br> For example, 500 means an internal server error
5. Use Nesting on Endpoints to Show Relationships <br>
`https://mysite.com/posts/author` would make a valid nesting in this case. <br> `https://mysite.com/posts/postId/comments`
6. Use Filtering, Sorting, and Pagination to Retrieve the Data Requested <br>
`https://mysite.com/posts?tags=javascript`
7. Use SSL for Security <br>
SSL stands for secure socket layer. It is crucial for security in REST API design. This will secure your API and make it less vulnerable to malicious attacks.
The clear difference between the URL of a REST API that runs over SSL and the one which does not is the “s” in HTTP:
`https://mysite.com/posts` runs on SSL.
`http://mysite.com/posts` does not run on SSL.
8. Provide Accurate API Documentation <br>
Swagger???  


- Express.js, GET, POST. Демонстрация на обработка на POST заявка с прикачен файл. Записване на качения файл: снимка за потребителския профил

# Node versions 
The examples project is created with 

```
iarabadzhiyski:~$ npm -v
6.14.15
iarabadzhiyski:~$ node -v
v14.18.0
```

  
# How to run the examples?

- `npm i` to install the npm dependencies 
- `npm run dev` to locally run the example

# ENV variables
- `PORT` - defaulted to `8000`
- `API_BASE_URL` - defaulted to `/` 
